var api = {};
api.local = 'ajax.php';


var data = {};
data.currencies = null;
var app = {
	init: function() {

		if(request_from)
			config.default.from = request_from;
		if(request_to)
			config.default.to = request_to;

		
		document.querySelector("#value").addEventListener("blur", function (event) {
			event.preventDefault();
			app.convert(false, false);
		}, true);

		document.querySelector("#value").addEventListener("keypress", function (event) {
			if (event.which == 13) {
				app.convert(false, false);
			}
		}, true);

		document.querySelector(".donate").addEventListener("click", function (event) {
			event.preventDefault();
			app.toggleClass(".donate-list","show")
		}, true);

		document.querySelector("#from").addEventListener("change", function (event) {
			event.preventDefault();
			app.convert(false, false);
		}, true);

		document.querySelector("#to").addEventListener("change", function (event) {
			event.preventDefault();
			app.convert(false, false);
		}, true);

		document.querySelector(".main .calculator .convert i").addEventListener("click", function (event) {
			event.preventDefault();
			app.truncate();
			app.convert(false, false);
		}, true);





		
		
			app.addClass(".loading-main","ishide");
			setTimeout(function () {
				var elem = document.querySelector(".loading-main");
				elem.parentNode.removeChild(elem);
			},1000);
		

		app.loadCurreny();
		app.registerWorker();

	},
	truncate: function(){
		
		var from = document.querySelector( "#from" ).value;
		var to = document.querySelector( "#to" ).value;
		
		document.querySelector("#to").selectedIndex = document.querySelector("#to").querySelector('option[value="' + from + '"]').index;
		document.querySelector("#from").selectedIndex = document.querySelector("#from").querySelector('option[value="' + to + '"]').index;

		
	},
	loadCurreny: function(){
		//jQuery.getJSON(config.baseurl+api.currency, {t:1}, function(json, textStatus) {
		  data.currencies= currencies.rows;
		  app.renderSelect();
		//});
	},
	renderSelect: function(){
		
		var _selectFrom = document.querySelector("#from");
		var _selectTo = document.querySelector("#to");
		data.currencies.forEach(function(val,index){
			_selectFrom.options[_selectFrom.options.length] = new Option(val.name + " (" + val.code + ")", val.code);
			_selectTo.options[_selectTo.options.length] = new Option(val.name + " (" + val.code + ")", val.code);
		});
		
		_selectFrom.selectedIndex = _selectFrom.querySelector('option[value="' + config.default.from + '"]').index;
		_selectTo.selectedIndex = _selectTo.querySelector('option[value="' + config.default.to + '"]').index;

		app.convert(config.default.from,config.default.to);
	},
	convert: function(from,to){
		app.addClass(".main .calculator .convert i","loading");
		
		if(!from)
			from = document.querySelector("#from").value;
		if(!to)
			to = document.querySelector("#to").value;
	
		
		app.post(config.baseurl+api.local, "from="+from+"&to="+to+"&token="+token+"&k="+true, function(json) {

				json = JSON.parse(json);
				  if(json.success)
					{

						
						app.renderResult(json,from,to);
					}
					else
					{
						if(json.error)
							document.querySelector("#result").value = json.error;
						else
							document.querySelector("#result").value = config.error;
					  
					}
					app.removeClass(".main .calculator .convert i", "loading");

			
		},"json");

	


	},
	setCache: function(value,from,to,result)
	{
		app.post(config.baseurl+api.local, "result="+result+"&value="+value+"&from="+from+"&to="+to+"&token="+token, function(data, textStatus, xhr) {
			/*optional stuff to do after success */
		});
	},
	registerWorker: function()
	{
		if (!config.pwa)
			return false;
		if ('serviceWorker' in navigator) {
			
				navigator.serviceWorker.register('/sw.js', { scope: '/' }).then(function (registration) {
					// Registration was successful
					console.log('ServiceWorker registration successful with scope: ', registration.scope);
				}, function (err) {
					// registration failed :(
					console.log('ServiceWorker registration failed: ', err);
				});
			
		}
	},
	botCheck: function(){
		var botPattern = "(googlebot\/|Googlebot-Mobile|Googlebot-Image|Google favicon|Mediapartners-Google|bingbot|slurp|java|wget|curl|Commons-HttpClient|Python-urllib|libwww|httpunit|nutch|phpcrawl|msnbot|jyxobot|FAST-WebCrawler|FAST Enterprise Crawler|biglotron|teoma|convera|seekbot|gigablast|exabot|ngbot|ia_archiver|GingerCrawler|webmon |httrack|webcrawler|grub.org|UsineNouvelleCrawler|antibot|netresearchserver|speedy|fluffy|bibnum.bnf|findlink|msrbot|panscient|yacybot|AISearchBot|IOI|ips-agent|tagoobot|MJ12bot|dotbot|woriobot|yanga|buzzbot|mlbot|yandexbot|purebot|Linguee Bot|Voyager|CyberPatrol|voilabot|baiduspider|citeseerxbot|spbot|twengabot|postrank|turnitinbot|scribdbot|page2rss|sitebot|linkdex|Adidxbot|blekkobot|ezooms|dotbot|Mail.RU_Bot|discobot|heritrix|findthatfile|europarchive.org|NerdByNature.Bot|sistrix crawler|ahrefsbot|Aboundex|domaincrawler|wbsearchbot|summify|ccbot|edisterbot|seznambot|ec2linkfinder|gslfbot|aihitbot|intelium_bot|facebookexternalhit|yeti|RetrevoPageAnalyzer|lb-spider|sogou|lssbot|careerbot|wotbox|wocbot|ichiro|DuckDuckBot|lssrocketcrawler|drupact|webcompanycrawler|acoonbot|openindexspider|gnam gnam spider|web-archive-net.com.bot|backlinkcrawler|coccoc|integromedb|content crawler spider|toplistbot|seokicks-robot|it2media-domain-crawler|ip-web-crawler.com|siteexplorer.info|elisabot|proximic|changedetection|blexbot|arabot|WeSEE:Search|niki-bot|CrystalSemanticsBot|rogerbot|360Spider|psbot|InterfaxScanBot|Lipperhey SEO Service|CC Metadata Scaper|g00g1e.net|GrapeshotCrawler|urlappendbot|brainobot|fr-crawler|binlar|SimpleCrawler|Livelapbot|Twitterbot|cXensebot|smtbot|bnf.fr_bot|A6-Indexer|ADmantX|Facebot|Twitterbot|OrangeBot|memorybot|AdvBot|MegaIndex|SemanticScholarBot|ltx71|nerdybot|xovibot|BUbiNG|Qwantify|archive.org_bot|Applebot|TweetmemeBot|crawler4j|findxbot|SemrushBot|yoozBot|lipperhey|y!j-asr|Domain Re-Animator Bot|AddThis)";
	          var re = new RegExp(botPattern, 'i');
	          var userAgent = navigator.userAgent;
	          if (re.test(userAgent)) {
	              return true;
	          }else{
	            return false;
	          }
	},
	formatCurrency: function(number,to)
	{
		var fixed = config.fixed;
		if(parseFloat(number).toFixed(fixed) <= 1 )
			fixed = config.fixed2;
		if(app.botCheck())
			return to+" "+parseFloat(number).toFixed(fixed);

		try{
	  		return new Intl.NumberFormat('en-US', { maximumFractionDigits:fixed,style: 'currency', currency: to }).format(number);

	  	}catch(e)
	  	{
	  		return  to+" "+new Intl.NumberFormat('en-US',{maximumFractionDigits:fixed}).format(number);

	  	}

	},
	renderResult: function(json,from,to)
	{


		var value = document.querySelector("#value").value;

		if(!value || value <= 0)
		{
			value = 1;
			document.querySelector("#value").value = value;
		}

		if(value>99999)
		{
			value = 99999;
			document.querySelector("#value").value = value;
		}


		var number =parseFloat((json.ticker.price)*value);
		var numberChange =parseFloat((json.ticker.change));

		var result = '';

		result = app.formatCurrency(number,to);
	  	numberChange = app.formatCurrency(numberChange,to);


		document.querySelector("#result").value = result;
		app.removeClass(".main .calculator .convert i", "loading");
	  	
	  	document.title = config.title+" | "+value+" "+from+" to "+to+" = "+result;
		document.querySelector('meta[name="description"]').setAttribute("content", value+" "+from+" to "+to+" = "+result+" | "+config.description);
		
		app.setCache(value,from,to,number);

	  

	  	var stateObj = { foo: "bar" };
		history.pushState(stateObj, "convert", config.baseurl+value+"/"+from+"/"+to);



	},
	addClass: function (elements, myClass) {
			if (!elements) { return; }
			if (typeof (elements) === 'string') {
				elements = document.querySelectorAll(elements);
			}
			else if (elements.tagName) { elements = [elements]; }
			for (var i = 0; i < elements.length; i++) {
				if ((' ' + elements[i].className + ' ').indexOf(' ' + myClass + ' ') < 0) {
					elements[i].className += ' ' + myClass;
				}
			}
		},

	toggleClass:function (elements, myClass) {
			if (!elements) { return; }
			if (typeof (elements) === 'string') {
				elements = document.querySelectorAll(elements);
			}
			else if (elements.tagName) { elements = [elements]; }
			for (var i = 0; i < elements.length; i++) {
				elements[i].classList.toggle(myClass);
			}
		},

	removeClass: function (elements, myClass) {
			if (!elements) { return; }
			if (typeof (elements) === 'string') {
				elements = document.querySelectorAll(elements);
			}
			else if (elements.tagName) { elements = [elements]; }
			var reg = new RegExp('(^| )' + myClass + '($| )', 'g');
			for (var i = 0; i < elements.length; i++) {
				elements[i].className = elements[i].className.replace(reg, ' ');
			}
		},


	post:function (url, data, callback) {

			var oReq = new XMLHttpRequest();
			oReq.onload = function (response) {
				callback(response.target.responseText);
			};
			oReq.open('POST', url, true);
			oReq.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded; charset=UTF-8');
			oReq.send(data);
		}
}
window.onload = function(event){
	app.init();
	
}
window.onpopstate = function (event) {
    location.reload();
}
